<template>
	<f7-page 
        name="financialreport" 
        @page:beforein="onPageBeforeIn"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Kas">
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">
                <small>{{ tabText }}</small>
                <span>Rp {{ balance.format(2,0,'.',',') }}</span>
            </f7-nav-title>
            <f7-nav-right>
                <f7-link href="/financial-reports/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

		<!-- Page content-->
        <f7-block v-if="financialReportCategories.length > 0">
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleFinancialReportCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
                <f7-link @click="handleFinancialReportCategory('bulan-ini')" :class="`gradient-box${slugify(currentCategory) == 'bulan-ini' ? ' tab-link-active' : ''}`">
					<span class="">Bulan Ini</span>									
				</f7-link>
                <f7-link @click="handleFinancialReportCategory('bulan-sebelumnya')" :class="`gradient-box${slugify(currentCategory) == 'bulan-sebelumnya' ? ' tab-link-active' : ''}`">
					<span class="">Bulan Sebelumnya</span>									
				</f7-link>
                <f7-link @click="handleFinancialReportCategory('pemasukan')" :class="`gradient-box${slugify(currentCategory) == 'pemasukan' ? ' tab-link-active' : ''}`">
					<span class="">Pemasukan</span>									
				</f7-link>
                <f7-link @click="handleFinancialReportCategory('pengeluaran')" :class="`gradient-box${slugify(currentCategory) == 'pengeluaran' ? ' tab-link-active' : ''}`">
					<span class="">Pengeluaran</span>									
				</f7-link>
				<f7-link @click="handleFinancialReportCategory(item.slug)" :class="`gradient-box${slugify(currentCategory) == item.slug ? ' tab-link-active' : ''}`" v-for="(item, index) in financialReportCategories" :key="index">
					<span class="">{{ item.name }}</span>									
				</f7-link>
                <f7-link @click="handleFinancialReportCategory('transaksi-saya')" :class="`gradient-box${slugify(currentCategory) == 'transaksi-saya' ? ' tab-link-active' : ''}`">
					<span class="">Transaksi Saya</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>

        <f7-block v-if="!financialReportLoading && financialreports.length > 0">
            <f7-link :data-financialreport="JSON.stringify(item)" href="#" class="card-link display-block" v-for="(item, index) in financialreports" v-bind:key="index">
                <f7-card class="card-shadow">                    
                    <f7-card-content :padding="true">
                        <div class="card-status">
                            {{ dateFormat(item.updated) }}
                            <f7-chip outline :text="statusText(item.status)" :color="statusColor(item.status)" class="float-right"></f7-chip>
                        </div>
                        <div class="card-info">
                            <f7-row>
                                <f7-col>
                                    <span class="card-category">{{ item.category.name }}</span>
                                    <span class="display-block no-margin">Periode {{ dateFormat(item.period, 'MMMM') }}</span>
                                </f7-col>
                                <f7-col>
                                    <span class="card-amount">Rp {{ item.trx_type == 'credit' ? item.credit.format(2,0,'.',',') : item.debit.format(2,0,'.',',') }}</span>
                                </f7-col>
                            </f7-row>
                        </div>
                        <div class="card-payer">
                            <f7-row>
                                <f7-col>
                                    <span class="card-payer">Diterima Dari:</span>
                                    <span class="card-payer-name">{{ item.author.profile.fullname  }}</span>
                                </f7-col>
                                <f7-col v-if="item.status == 'paid'">
                                    <span class="card-payer">Penerima:</span>
                                    <span class="card-payer-name">{{ item.recepient }}</span>
                                </f7-col>
                            </f7-row>
                        </div>
                    </f7-card-content>                        
                </f7-card>
            </f7-link>
        </f7-block>

        <f7-block v-else-if="!financialReportLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="money_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>

        <f7-block v-else-if="financialReportLoading">
            <f7-card
            v-for="n in 4"
            :key="n"
            class="skeleton-text"
            title="Card Header"
            content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit."
            footer="Card Footer"
            ></f7-card>
        </f7-block>

    </f7-page>
</template>
<script>
import moment from 'moment';
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'FinancialReport',
    data(){
        return {
            tabText: 'Saldo Terakhir',
            balance: 0,
            financialReportLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua',
            currentPeriod: null,
            currentCategoryId: null,
            transactionType: null,
            authorId: null
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('category', ['financialReportCategories']),
		...mapGetters('financialreport', [
			'financialreports',
            'pagination',
            'totalcredit',
            'totaldebit'
		])
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;

        $$('div[data-name="financialreport"]').on('click', 'a.card-link', function(){
            let financialreport = JSON.parse($$(this).data('financialreport'));
            
            if(financialreport.author.id == self.user.id && self.currentCategory == 'Transaksi Saya'){
                self.showActionSheet(financialreport);
            }else{
                self.$f7router.navigate('/financial-reports/view/'+financialreport.id+'/', {
                    ignoreCache: true
                });
            }
        });
    },
    methods: {
        dateFormat,
        slugify,
        statusText(status){
            if(status == 'waiting'){
                return 'Menunggu Konfirmasi'
            }else if(status == 'paid'){
                return 'Lunas';
            }else{
                return 'Belum Lunas';
            }
        },
        statusColor(status){
            if(status == 'waiting'){
                return 'orange'
            }else if(status == 'paid'){
                return 'green';
            }else{
                return 'red';
            }
        },
        getCategories(){
			const self = this;
			const app = self.$f7;

			self.$store.dispatch('category/getCategories', {
				module: 'financialreport',
				page: 1,
                perpage: 100,
                only: 'id,name,slug'
			});
		},
        getFinancialReports(page, loadmore){
			const self = this;
            const app = self.$f7;
            
			self.$store.dispatch('financialreport/getFinancialReports', {
				page: page,
                perpage: 25,
                loadmore: loadmore,
                category: self.currentCategoryId,
                author_id: self.authorId,
                trx_type: self.transactionType,
                residential: self.user.residential != null ? self.user.residential.id : null,
                period: self.currentPeriod,
                only: 'id,number,title,note,recepient,trx_type,status,credit,debit,period,balance,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
			}).then(() => {                
                setTimeout(() => {
                    let balance = self.financialreports.length > 0 ? self.financialreports[self.financialreports.length-1].balance : 0
                    self.balance = balance;
                    self.showPreloader = self.pagination.has_next;
                    self.financialReportLoading = false;
                }, 100);
            });
		},
        onPageBeforeIn(){
            const self = this;

            self.getCategories();
            self.getFinancialReports(1, false);
            
        },
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'financialreport'){
                self.currentCategory = 'Semua';
                self.currentPeriod = null;
                self.currentCategoryId = null;
                self.transactionType = null;
                self.authorId = null;
                self.$store.dispatch('category/resetCategories', {
                    module: 'financialreport'
                });
                self.$store.dispatch('financialreport/resetFinancialReports');
            }
        },
        onPageRefresh(e, done){
            const self = this;

            self.$store.dispatch('category/resetCategories', {
                module: 'financialreport'
            }).then(()=>{
                self.financialReportLoading = false;
                self.getCategories();
            });

            self.getFinancialReports(1, false);
            done();
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getFinancialReports(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleFinancialReportCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.financialReportLoading = true;
            
            if(['semua', 'bulan-ini', 'bulan-sebelumnya', 'pemasukan', 'pengeluaran', 'transaksi-saya'].indexOf(category) == -1){                
                for(const x of self.financialReportCategories){
                    if(x.slug == category){
                        self.currentCategory = x.name;
                        self.currentCategoryId = x.id;
                        self.tabText = 'Total ' + x.name;
                        break;
                    }
                }
                self.transactionType = null;
                self.authorId = null;

            }else if(category == 'bulan-ini'){
                self.authorId = null;
                self.transactionType = null;
                self.currentCategoryId = null;
                self.currentCategory = 'Bulan Ini';
                self.tabText = 'Saldo Terakhir';
                self.currentPeriod = moment(new Date()).format('YYYY-MM-DD');

            }else if(category == 'bulan-sebelumnya'){
                self.authorId = null;
                self.transactionType = null;
                self.currentCategoryId = null;
                self.currentCategory = 'Bulan Sebelumnya';
                self.tabText = 'Saldo Terakhir';
                self.currentPeriod = moment(new Date()).subtract(1, 'months').format('YYYY-MM-DD');

            }else if(category == 'pemasukan'){
                self.authorId = null;
                self.transactionType = 'credit';
                self.currentCategoryId = null;
                self.currentCategory = 'Pemasukan';
                self.tabText = 'Total Pemasukan';
                self.currentPeriod = null;

            }else if(category == 'pengeluaran'){
                self.authorId = null;
                self.transactionType = 'debit';
                self.currentCategoryId = null;
                self.currentCategory = 'Pengeluaran';
                self.tabText = 'Total Pengeluaran';
                self.currentPeriod = null;

            }else if(category == 'transaksi-saya'){
                self.authorId = self.user.id;
                self.transactionType = null;
                self.currentCategoryId = null;
                self.currentCategory = 'Transaksi Saya';
                self.tabText = 'Total Transaksi';
                self.currentPeriod = null;
            }else{
                self.authorId = null;
                self.transactionType = null;
                self.currentCategoryId = null;
                self.currentCategory = 'Semua';
                self.tabText = 'Saldo Terakhir';
                self.currentPeriod = null;
            }

            self.$store.dispatch('financialreport/resetFinancialReports').then(()=>{
                self.getFinancialReports(1, false);
            });
            
        },
        showActionSheet(financialreport){
            const self = this;
            const app = self.$f7;

            let buttons = [{
                text: financialreport.title,
                label: true
            }, {
                text: 'Lihat',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/financial-reports/view/'+financialreport.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Ubah',
                close: true,
                onClick: function(actions, e){
                    self.$f7router.navigate('/financial-reports/edit/'+financialreport.id+'/', {
                        ignoreCache: true
                    });
                }
            }, {
                text: 'Hapus',
                close: true,
                onClick: function(actions, e){
                    app.dialog.confirm('Anda yakin ingin menghapus laporan keuangan ini?', function(){
                        app.preloader.show('green');
                        self.$store.dispatch('financialreport/deleteFinancialReport', {
                            id: financialreport.id,
                            only: 'id,number,title,note,recepient,trx_type,status,credit,debit,period,balance,created,updated,category.id,category.name,medias.id,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residential.name,residential.address,residential.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
                        }).then((response)=>{
                            app.preloader.hide();
                            self.$f7router.refreshPage();
                        });
                    });
                }
            }, {
                text: 'Batal',
                color: 'red',
                close: true
            }];

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
      
        },
    }
}
</script>
